import { getStorageCall } from '@yehonadav/safestorage';
export declare type LogType = 'log' | 'info' | 'error' | 'debug' | 'exception' | 'trace' | 'warn';
export declare type LogMessage = {
    type: LogType;
    date: Date;
    message: string;
    object: any;
};
export declare type ConsoleState = {
    logs: LogMessage[];
};
export declare type State = {
    console: ConsoleState;
    open: boolean;
    persist: boolean;
    enabled: boolean;
};
export declare type PersistOptions = {
    name: string;
    whitelist: (keyof State)[];
    getStorage: typeof getStorageCall;
};
export declare type Logger = Console & {
    setVersion: (version: string) => void;
};
